
#include <iostream>

#include "counterexpression.h"

using namespace cexp;
using namespace std;

void CExpCompare::to_stream(std::ostream& output) const { 
    output << "(" << counter_name << " ";
    switch (op) {
        case EQ:  output << "="; break;
        case NEQ: output << "!="; break;
        case GT:  output << ">"; break;
        case LT:  output << "<"; break;
        case GTE: output << ">="; break;
        case LTE: output << "<="; break;
    }
    output << " " << value << ")";
}


counterexp_ptr CExpCompare::normal_form(bool negative) {
    CompOp new_op;
    if (negative) {
        switch (op) {
            case EQ:  new_op = NEQ; break;
            case NEQ: new_op = EQ; break;
            case GT: new_op = LTE; break;
            case LT: new_op = GTE; break;
            case GTE: new_op = LT; break;
            case LTE: new_op = GT; break;
        }
    } else {
        new_op = op;
    }
    return boost::make_shared<CExpCompare>(counter_name, new_op, value);
}

